SystemOrganization addCategory: #'Smallchange-Core'!
SystemOrganization addCategory: #'Smallchange-Core-Commands'!

!Number methodsFor: '*smallchange-core' stamp: 'StuartHerring 12/11/2011 11:28'!
printAsCurrency
	| s|
	s := WriteStream with: ''.
	self printOn: s showingDecimalPlaces: 2.
	^s contents! !

MbObject subclass: #ScObject
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScObject class methodsFor: 'instance creation' stamp: 'StuartHerring 12/11/2011 14:19'!
profile: aProfile
	^self basicNew
		initializeWithProfile: aProfile;
		yourself.! !

!ScObject methodsFor: 'initialization' stamp: 'StuartHerring 12/11/2011 14:20'!
initializeWithProfile: aProfile
	self initialize.
	profile := aProfile! !

ScObject subclass: #ScPool
	instanceVariableNames: 'name transactions pool account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScPool subclass: #ScAccount
	instanceVariableNames: 'openingBalance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScAccount methodsFor: 'initialization' stamp: 'StuartHerring 1/18/2012 21:02'!
initialize
	super initialize.
	openingBalance := 0.! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:55'!
openingBalance
	<label: 'Opening Balance'>
	<required>
	^openingBalance! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:55'!
openingBalance: anAmount
	openingBalance := anAmount.! !

!ScPool methodsFor: 'actions' stamp: 'StuartHerring 12/11/2011 15:40'!
addTransaction: aTransaction
	transactions add: aTransaction! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 15:55'!
asString
	^name! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:56'!
balance
	^transactions inject: self openingBalance into: [ :total :this | total + this amount ]! !

!ScPool methodsFor: 'initialization' stamp: 'StuartHerring 1/18/2012 20:57'!
initialize
	super initialize.
	transactions := OrderedCollection new.
! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 16:47'!
name
	<label: 'Name'>
	<required>
	^name! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 11:05'!
name: aName
	name := aName! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:55'!
openingBalance
	^0! !

!ScPool methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 20:19'!
removeTransaction: aTransaction
	transactions remove: aTransaction! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 15:51'!
transactions
	^transactions! !

ScObject subclass: #ScTransaction
	instanceVariableNames: 'comment amount date pool account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:20'!
account
	<valueSelector: #accountList>
	<required>
	^account! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
account: anAccount
	self set: #account to: anAccount! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/29/2012 10:43'!
accountList
	^profile accounts! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
amount
	<required>
	<currency: $$>
	^amount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
amount: anAmount
	self set: #amount to: anAmount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 15:06'!
comment
	^comment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
comment: aComment
	self set: #comment to: aComment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
date
	<date>
	^date! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
date: aDateAndTime
	self set: #date to: aDateAndTime! !

!ScTransaction methodsFor: 'initialization' stamp: 'StuartHerring 2/6/2012 21:47'!
initialize
	super initialize.
	date := Date today.! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:31'!
pool
	<valueSelector: #poolList>
	^pool! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
pool: aPool
	self set: #pool to: aPool! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/30/2012 18:31'!
poolList
	^profile pools! !

ScTransaction subclass: #ScTransferSource
	instanceVariableNames: 'transfer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScTransaction subclass: #ScTransferTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScObject subclass: #ScTransfer
	instanceVariableNames: 'source destination amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScTransfer methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2012 13:05'!
initialize
	super initialize.
	source := ScTransferSource for: self.
	destination := ScTransferTransaction for: self.! !

MbSimpleCommand subclass: #ScAddAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddAccount class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:18'!
profile: aProfile account: anAccount
	^self do: [ aProfile addAccount: anAccount ] undo: [ aProfile removeAccount: anAccount ]! !

MbSimpleCommand subclass: #ScAddPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddPool class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:08'!
profile: aProfile pool: aPool
	^self do: [ aProfile addPool: aPool ] undo: [ aProfile removePool: aPool ]! !

MbCommand subclass: #ScRecordTransaction
	instanceVariableNames: 'profile transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScRecordTransaction class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:58'!
profile: aProfile transaction: aTransaction
	^self new
		profile: aProfile transaction: aTransaction;
		yourself! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:56'!
do
	profile addTransaction: transaction.
	transaction account addTransaction: transaction.
	transaction pool ifNotNil: [ :p | p addTransaction: transaction]! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 18:07'!
printOn: aStream
	aStream nextPutAll: 'Spent $'! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:55'!
profile: aProfile transaction: aTransaction
	profile := aProfile.
	transaction := aTransaction.! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:59'!
undo
	transaction account removeTransaction: transaction.
	profile removeTransaction: transaction.
	transaction pool ifNotNil: [ :p | p removeTransaction: transaction ]! !

Object subclass: #ScProfile
	instanceVariableNames: 'name pools accounts recurringTransactions transactions primaryIncome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScProfile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:26'!
name: aName
	^self basicNew
		initializeWithName: aName;
		yourself.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:14'!
accounts
	^accounts! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:20'!
addAccount: anAccount
	(accounts anySatisfy: [ :p | p name = anAccount name]) 
		ifTrue: [ MbValidationError signal: 'An account with the name ', anAccount name, ' already exists' ].
	accounts add: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:19'!
addPool: aPool
	(pools anySatisfy: [ :p | p name = aPool name]) 
		ifTrue: [ MbValidationError signal: 'A pool with the name ', aPool name, ' already exists' ].
	pools add: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 12/11/2011 15:45'!
addTransaction: aTransaction
	transactions add: aTransaction! !

!ScProfile methodsFor: 'initialization' stamp: 'StuartHerring 12/8/2011 18:02'!
initializeWithName: aName
	self initialize.
	name := aName.
	pools := OrderedCollection new.
	accounts := OrderedCollection new.
	recurringTransactions := OrderedCollection new.
	transactions := OrderedCollection new.
	primaryIncome := nil.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:07'!
name
	^name! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newAccount
	^ScAccount profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newPool
	^ScPool profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newTransaction
	^ScTransaction profile: self! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 10:52'!
pools
	^pools! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:19'!
removeAccount: anAccount
	accounts remove: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:20'!
removePool: aPool
	pools remove: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 20:57'!
removeTransaction: aTransaction
	transactions remove: aTransaction! !
